﻿using System.Collections.Generic;
using System.Net;
using GemBox.Spreadsheet;
using Microsoft.Xrm.Client.Services;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Messages;
using Microsoft.Xrm.Sdk.Metadata;
using Microsoft.Xrm.Sdk.Query;
using MsCrmTools.Translator;
using MsCrmTools.Translator.AppCode;
using Microsoft.Xrm.Client;

namespace Console.Test
{
    class Program
    {
        private const string filePath = @"C:\Users\ttouzard\Desktop\test.xlsx";

        static void Main(string[] args)
        {
            SpreadsheetInfo.SetLicense("EKME-L4GS-6EXL-R9IK");

            Export();
            //Import();
            //Export();
            //Import();
            //Export();
            //Import();
            //Export();
            //Import();
            //Export();
            //Import();
            
            
            //System.Console.WriteLine("Export?");
            //if (System.Console.ReadLine().ToLower() == "y")
            //{
            //    Export();
            //}
            //System.Console.WriteLine("Import?");
            //if (System.Console.ReadLine().ToLower() == "y")
            //{
            //    Import();
            //}
        }

        private static void Import()
        {
            var service = new OrganizationService(CrmConnection.Parse("Url=http://10.0.0.4/TEST;Domain=ENTREPRISE;Username=administrateur;Password=pass@word1"));

            //var file = ExcelFile.Load(@"C:\Users\ttouzard\Desktop\test.xlsx", LoadOptions.XlsxDefault);

            var e = new Engine();
            e.Import(filePath, service);
            return;
            //System.Console.WriteLine("Entités...");

            //var et = new EntityTranslation();
            //et.Import(file.Worksheets[0], service);

            //System.Console.WriteLine("Attributs...");

            //var at = new AttributeTranslation();
            //at.Import(file.Worksheets[1], service);

            //System.Console.WriteLine("Options...");

            //var ot = new OptionSetTranslation();
            //ot.Import(file.Worksheets[2], service);

            //System.Console.WriteLine("Booléens...");

            //var bt = new BooleanTranslation();
            //bt.Import(file.Worksheets[3], service);

            //System.Console.WriteLine("Vues...");

            //var vt = new ViewTranslation();
            //vt.ImportView(file.Worksheets[4],service);

            //System.Console.WriteLine("Formulaires...");

            //var forms = new List<Entity>();
            //var ft = new FormTranslation();
            
            ////ft.ImportFormName(file.Worksheets[5], service);

            //System.Console.WriteLine("Contenu de formulaire...");

            //ft.PrepareFormTabs(file.Worksheets[6], service, forms);
            //ft.PrepareFormSections(file.Worksheets[7], service, forms);
            //ft.PrepareFormLabels(file.Worksheets[8], service, forms);
            //ft.ImportFormsContent(service, forms);

            //System.Console.WriteLine("Fin!");
            //System.Console.ReadLine();
        }

        private static void Export()
        {
            //var lcids = new List<int> { 1036 };
            var lcids = new List<int> { 1036, 1033 };
            var emds = new List<EntityMetadata>();

            //var service = new OrganizationService(CrmConnection.Parse("Url=http://frdewea1/Development;Domain=GCD;Username=tantou;Password=ttouzard"));
            //var service = new OrganizationService(CrmConnection.Parse("Url=http://vm-ttd-crm/TEST2"));
            var service = new OrganizationService(CrmConnection.Parse("Url=http://10.0.0.4/TEST;Domain=ENTREPRISE;Username=administrateur;Password=pass@word1"));

            //WebRequest.DefaultWebProxy = WebRequest.GetSystemWebProxy();
            //WebRequest.DefaultWebProxy.Credentials = new NetworkCredential("tantou", "ttouzard", "GCD");
            //var test = Microsoft.Crm.Services.Utility.DeviceIdManager.LoadOrRegisterDevice();
            //var service = new OrganizationService(CrmConnection.Parse("Url=https://javista.crm4.dynamics.com;Username=tanguy.touzard@javista.com;Password=Emeline18*;DeviceID=" + test.UserName.UserName + ";DevicePassword=" + test.UserName.Password));

            //var request = new RetrieveEntityRequest { LogicalName = "account", EntityFilters = EntityFilters.Attributes };
            //var response = (RetrieveEntityResponse)service.Execute(request);
            //emds.Add(response.EntityMetadata);
            //request = new RetrieveEntityRequest { LogicalName = "contact", EntityFilters = EntityFilters.Attributes };
            //response = (RetrieveEntityResponse)service.Execute(request);
            //emds.Add(response.EntityMetadata);

            RetrieveAllEntitiesRequest request = new RetrieveAllEntitiesRequest
            {
                EntityFilters = EntityFilters.Entity | EntityFilters.Attributes 
            };

            RetrieveAllEntitiesResponse response = (RetrieveAllEntitiesResponse)service.Execute(request);

            foreach (EntityMetadata emd in response.EntityMetadata)
            {
                if (emd.DisplayName.UserLocalizedLabel != null && emd.IsCustomizable.Value)
                {
                    emds.Add(emd);
                }
            }

            var file = new ExcelFile();


            System.Console.WriteLine("Entities...");
            var sheet = file.Worksheets.Add("Entities");
            var et = new EntityTranslation();
            et.Export(emds, lcids, sheet);

            System.Console.WriteLine("Ribbon...");
            var sheet1 = file.Worksheets.Add("Ribbon");
            var rt = new RibbonTranslation();
            rt.Export(lcids, sheet1, false, service);


            System.Console.WriteLine("Attributes...");
            var sheet2 = file.Worksheets.Add("Attributes");
            var at = new AttributeTranslation();
            at.Export(emds, lcids, sheet2);

            System.Console.WriteLine("Options...");
            var sheet31 = file.Worksheets.Add("Global Options");
            var ot1 = new GlobalOptionSetTranslation();
            ot1.Export(lcids, sheet31, service);

            System.Console.WriteLine("Options...");
            var sheet3 = file.Worksheets.Add("Options");
            var ot = new OptionSetTranslation();
            ot.Export(emds, lcids, sheet3);

            System.Console.WriteLine("Booleans...");
            var sheet4 = file.Worksheets.Add("Booleans");
            var bt = new BooleanTranslation();
            bt.Export(emds, lcids, sheet4);

            System.Console.WriteLine("Views...");
            var sheet5 = file.Worksheets.Add("Views");
            var vt = new ViewTranslation();
            vt.Export(emds, lcids, sheet5, service);

            System.Console.WriteLine("Formulaires...");
            var ft = new FormTranslation();
            ft.Export(emds, lcids, file, service, new FormExportOption { ExportFormTabs = true, ExportFormSections = true, ExportFormFields = true });

            file.Save(filePath, SaveOptions.XlsxDefault);
        }
    }
}
